;**************|******************************************************************************
;              |        8-     
;              |                         HD44780 (HITACHI)
; bf_fr_4.asm  |      (    BF:   ).
;              |******************************************************************************
;              |        **********   4-  **********
;*********************************************************************************************
;   "   PIC " (http://ikarab.narod.ru)
;*********************************************************************************************
;     :
; - Alberto Seneluk (), E-mail:alcurbokran@yahoo.com.ar
;    .
; -   (), E-mail:karabea@lipetsk.ru    
;   , , ,    ( "..."). 
; -   (), E-mail:ew8ar@server.by
;     "" .
;*********************************************************************************************
;     : 1000000 . (1 .).
;  : 1 .
; "": PIC16F84A.
; "":     / HD44780: 2   16  (216).
; 4-,  :      RB4...7.
;    :
; RA0 - RW,
; RA1 - RS,
; RA2 - E,
;  4000  (1 ..= 1 .).
;---------------------------------------------
;  : 317    .
;*********************************************************************************************
;                               ( )!   
;*********************************************************************************************
            LIST       p=16F84a    ; "" MPLAB   PIC16F84A.
            __CONFIG   03FF5H      ;    :
                                   ;   , WDT ,   XT.
;=============================================================================================
;         .
;=============================================================================================
IndF        equ        00h         ;     FSR.
Tmr0        equ        01h         ;  TMR0.
OptionR     equ        01h         ;  Option-1.
PC          equ        02h         ;  .
Status      equ        03h         ;  Status.
FSR         equ        04h         ;   .
PortA       equ        05h         ;  Port A.
TrisA       equ        05h         ;  Tris A-1.
PortB       equ        06h         ;  Port B.
TrisB       equ        06h         ;  Tris B-1.
IntCon      equ        0Bh         ;  IntCon.     
;============================================================================================
;           .
;============================================================================================
LED0        equ        10h         ;    LED0.
LED1        equ        11h         ; ------------"----------- LED1.
LED2        equ        12h         ; ------------"----------- LED2.
LED3        equ        13h         ; ------------"----------- LED3.
LED4        equ        14h         ; ------------"----------- LED4.
LED5        equ        15h         ; ------------"----------- LED5.
LED6        equ        16h         ; ------------"----------- LED6.
LED7        equ        17h         ;    LED7.

Total       equ        18h         ;  .
Count1      equ        0Dh         ;    2/10 . 
TimerL      equ        1Bh         ;    .
TimerM      equ        1Ch         ;    .
TimerH      equ        1Dh         ;    .
TimerHH     equ        1Eh         ;     .
Mem         equ        1Fh         ;    2/10 .
Count       equ        20h         ;      .
PDel0       equ        22h         ;   .
PDel1       equ        23h         ;   .
PDel2       equ        24h         ;   .
TEMP        equ        25h         ;   .
TEMP2       equ        26h         ;   . .
;============================================================================================
;       .
;============================================================================================
F           equ        1           ;    .
W           equ        0           ;    .
;============================================================================================
;       .
;============================================================================================
RP0         equ        5           ;    ( Status).
RW          equ        0           ;  0  PortA ( RA0 -  RW).
RS          equ        1           ;  1  PortA ( RA1 -  RS).
E           equ        2           ;  2  PortA ( RA2 -  E).
BF          equ        7           ;  7  PortB.
Z           equ        2           ;   .
C           equ        0           ;  -.
;============================================================================================
;     .
;============================================================================================
            org        0           ;     PC -  .
            goto       START       ;    .
;********************************************************************************************


;********************************************************************************************
;------------------------------- ""   ---------------------------------
;********************************************************************************************
; ""   .
;============================================================================================
LCD_INIT    call WAIT_15M ;   15 
;   
;              MOVLW     0X30  ; 8    
;              MOVWF     PortB
;              BSF       PortA,E
;              NOP
;              BCF       PortA,E
;              CALL      WAIT_5M        ; 5 
;--------------------------------------------------------------------------------------------
;              BSF       PortA,E     ; 8    
;              NOP
;              BCF       PortA,E
;              CALL      WAIT_100        ; 100 
;--------------------------------------------------------------------------------------------
;              BSF       PortA,E     ; 8    
;              NOP
;              BCF       PortA,E
;              CALL      WAIT_100        ; 100 
;--------------------------------------------------------------------------------------------
;              MOVLW     0X20  ; 4    
;              MOVWF     PortB
;              BSF       PortA,E
;              NOP
;              BCF       PortA,E
;              CALL      WAIT_100        ; 100 

; 
            movlw      b'00100000' ; : 4- , 2 , 57 .
            movwf     PortB
            bsf       PortA,E
            nop
            bcf       PortA,E
            call       READ_BF    ; ""      00100000.
;             call       WAIT_100        ; 100 
;---->      ENTER_BF.
LCD_INIT_1  movlw      b'00101000' ; : 4- , 2 , 57 .
            call       ENTER_BF    ; ""      00101000.
;---->      ENTER_BF.

            movlw      b'00001100' ; :  ,  
                                   ;  .
            call       ENTER_BF    ; ""      00001100.
;---->      ENTER_BF.

            movlw      b'00000001' ; :     ,
                                   ;     1- .
            call       ENTER_BF    ; ""      00000001.
;---->      ENTER_BF.
; *********************************************************************************************
;             CALL      WAIT_1M6     ; 5    1,64 
            movlw      0X06        ; :  
            call       ENTER_BF    ; ""      00000001.
            
            


            
; *********************************************************************************************
            return                 ;         
                                   ;   ,     DISPLAY.
;=============================================================================================
;  ""        BF
; (  4- ).
;=============================================================================================
ENTER_BF    movwf      Mem         ;   /  W  
            movwf      PortB       ; RB4...7 (  RB0...3  ).
;------------------------------------------
;     / ().
;------------------------------------------
;             nop                    ;   1 ..   ????????????????????????????????????????????
            bsf        PortA,E     ;     "1".
            nop                    ;   1 ..
            bcf        PortA,E     ;     "0".
;------------------------------------------
            swapf      Mem,W       ;  /      W.
            movwf      PortB       ;   /  W  
                                   ; RB4...7 (  RB0...3  ).
;------------------------------------------
;     / ().
;------------------------------------------           

;             nop                    ;   1 ..   ????????????????????????????????????????????
            bsf        PortA,E     ;     "1".
            nop                    ;   1 ..
            bcf        PortA,E     ;     "0".
;-------------------------------------------------
;     BF.
;-------------------------------------------------
;   .
;------------------------
READ_BF     bsf        Status,RP0  ;   1- .
            movlw      b'11110000' ;   W "11110000"
            movwf      TrisB       ; RB4...7   ,  RB0...3   .
            bcf        Status,RP0  ;   0- .
;             clrf       TEMP       ;   "0"   TEMP   ?????????????   ?????????????
            bcf        PortA,RS    ;    RS "0" ( ).
            bsf        PortA,RW    ;  RW  "1" (  ).
            nop                    ;   1 ..
            bcf        PortA,E     ;     "0".
POVTOR      bsf        PortA,E     ;     "1".
;             nop                    ;   1 ..       ????????????????????????????????????????????
;             bcf        PortA,E     ;     "0".
;-----------------------
;     LCD.
;-----------------------
            movf       PortB,W     ;    PortB  W.( )
            andlw      0xF0        ;          W
            movwf      TEMP        ;      TEMP
            bcf        PortA,E     ;     "0".
            nop
            bsf        PortA,E     ;     "1".
;             nop                    ;   1 ..       ????????????????????????????????????????????
;             bcf        PortA,E     ;     "0".????????????????????????????????????????????
            swapf      PortB,W     ;    PortB  W.( )
            andlw      0x0F        ;          W
            iorwf      TEMP        ;     TEMP. (    )
            bcf        PortA,E     ;     "0".
;-----------------------
;  .
;-----------------------

            btfsc      TEMP,BF    ;     BF.

            goto       POVTOR      ;  BF=1,      , 
                                   ; BF    "0" (  ).
;-----------------------
;  .
;-----------------------
;  BCF       RW     B7   
;       2    
;             bcf        PortA,E     ;     "0".   BF  LCD
            clrf       PortA       ;   "0"     (RW=0, RS=0, E=0).
            bsf        Status,RP0  ;   1- .
            clrf       TrisB       ;       .
            bcf        Status,RP0  ;   0- .

            return                 ;   .

;*********************************************************************************************

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;     ,    ,  
;     .       
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; :       - .  ROM  MPLAB.
;---------------------------------------------------------------------------------------------
TEXT_1      addwf      PC,F               ;  PC    W.
            dt         "-Please wait...-" ;   W    
                                          ;    .
;---------------------------------------------------------------------------------------------
TEXT_2      addwf      PC,F               ;   .
            dt         "  calculling... " ; -----"-----
;---------------------------------------------------------------------------------------------
TEXT_3      addwf      PC,F               ;   . 
            dt         " -max 30.0 MHz- " ; -----"-----
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;*********************************************************************************************
;        " -max 30.0 MHz- "  .
;*********************************************************************************************
;   " -max 30.0 MHz- "  1- .
;=============================================================================================
DISPLAY     call       LCD_INIT_1  ;     "" .
;---->      LCD_INIT_1.
;------------------------------
;    1- .
;------------------------------
            movlw      d'16'       ;   .16 (   
            movwf      Count       ; )   Count.
WR_1        movf       Count,W     ;    Count  W.
            sublw      d'16'       ; .16-Count=... (   W).
            call       TEXT_3      ;     TEXT_3.
;---->      TEXT_3.
            bsf        PortA,RS    ;    RS "1" (  ).
            call       ENTER_BF    ; ""     
                                   ;   .
;---->      ENTER_BF.
            decfsz     Count,F     ;     
                                   ;   .
            goto       WR_1        ;    =0,     WR_1.
                                   ;    =0,  
                                   ;  .
;=============================================================================================
;     2- .
;=============================================================================================
;   3-   2- .
;-------------------------------------------
            movlw      b'11000010' ;   DD RAM   42h,  
                                   ;       2- .
            call       ENTER_BF    ; ""      11000010.
;---->      ENTER_BF.
;----------------------------------------------------------
;      .
;----------------------------------------------------------
            movlw      .8          ;    (  ),
            movwf      Total       ;      .
;----------------------------------------------------------
;      LED.
;----------------------------------------------------------
            movlw      LED7        ;      ""
            movwf      FSR         ;  , , LED7,    
SNOVA       movf       IndF,W      ;   LED (6,5,4,3,2,1,0)   W.
;----------------------------------------------------------
;      2- 
; (""    ).
;----------------------------------------------------------
            bsf        PortA,RS    ;    RS "1" (  ).
            call       ENTER_BF    ; ""     
                                   ;   .
;---->      ENTER_BF.
;----------------------------------------------------------
;    LED,    .
;----------------------------------------------------------
            decf       FSR,F       ;    LED  1.
            decf       Total,F     ;      1.

            btfss      Status,Z    ;      Z.
            goto       SNOVA       ;    Total =0,     SNOVA.
                                   ;   =0,    .
;----------------------------------------------------------
;      , 
;     .
;----------------------------------------------------------
            movlw      20h         ;   W  "" (20h) 
            bsf        PortA,RS    ;    RS "1" (  ).
            call       ENTER_BF    ; ""     
                                   ;   .
;---->      ENTER_BF.

            movlw      48h         ;   W  "H" (48h)
            bsf        PortA,RS    ; ;  -   .
            call       ENTER_BF    ; -----------"------------                             
;---->      ENTER_BF.

            movlw      7Ah         ;   W  "z" (7Ah) 
            bsf        PortA,RS    ;  -   .
            call       ENTER_BF    ; -----------"------------
;---->      ENTER_BF.

            goto       START_1     ;     .

;*********************************************************************************************
;   "".
;*********************************************************************************************
;  .
;----------------------------------------
START       clrf       PortA       ;    A  "0" (RS=0, RW=0, E=0).

            bsf        Status,RP0  ;   1- .
            clrf       TrisB       ;       .
            movlw      b'00010000' ;  RA4/TOCKI   ,
            movwf      TrisA       ;  -  .
            bcf        Status,RP0  ;   0- .

            call       LCD_INIT    ;     "" .
;---->      LCD_INIT.

;*********************************************************************************************
;   ,      
; ""      .
;*********************************************************************************************
;   " Please wait... "  1- .
;=============================================================================================
;    1- .
;------------------------------
            movlw      d'16'       ;   .16 (   
            movwf      Count       ; )   Count.
WR_2        movf       Count,W     ;    Count  W.
            sublw      d'16'       ; .16-Count=... (   W).
            call       TEXT_1      ;     TEXT_1.
;---->      TEXT_1.
            bsf        PortA,RS    ;    RS "1" (  ).
            call       ENTER_BF    ; ""     
                                   ;   .
;---->      ENTER_BF.
            decfsz     Count,F     ;     
                                   ;   .
            goto       WR_2        ;    =0,     WR_2.
                                   ;    =0,  
                                   ;  .
;=============================================================================================
;   "  allculing... "  2- .
;=============================================================================================
;    2- .
;------------------------------
            movlw      b'11000000' ;   DD RAM   40h ( 
                                   ;      2- ).
            call       ENTER_BF    ; ""      11000000.
;---->      ENTER_BF.
;------------------------------
;    2- .
;------------------------------
            movlw      d'16'       ;   .16 (   
            movwf      Count       ; )   Count.
WR_3        movf       Count,W     ;    Count  W.
            sublw      d'16'       ;.16-Count=... (   W).
            call       TEXT_2      ;     TEXT_2.
;---->      TEXT_2. 
            bsf        PortA,RS    ;    RS "1" (  ).
            call       ENTER_BF    ; ""     
                                   ;   .
;---->      ENTER_BF.
            decfsz     Count,F     ; ;     
                                   ;   . 
            goto       WR_3        ;    =0,     WR_3.
                                   ;    =0,  
                                   ;  .
;*********************************************************************************************
;   .
;*********************************************************************************************
;  .
;----------------------------
START_1     clrf       IntCon      ;   .
            clrf       Tmr0        ;   0  TMR0.
            clrf       TimerH      ;   0  TimerH.
            clrf       TimerHH     ;   0  TimerHH.

            bsf        Status,RP0  ;   1- .
            movlw      b'00100111' ;   .=256   TMR0,
            movwf      OptionR     ;      
                                   ; RA4/TOCK1,  TMR0   .
;---------------------------------------------------------------------------------------------
;     "On"
;---------------------------------------------------------------------------------------------
            movlw      b'00011000' ;  RA3  RA4/TOCKI   .
On          movwf      TrisA       ;   W    TrisA,  .
            bcf        Status,RP0  ;   0- .
;---------------------------------------------------------------------------------------------
;    ,  .
;---------------------------------------------------------------------------------------------
            movlw      .11         ;   .11
            movwf      PDel0       ;   PDel0.

LOOP_1      movlw      .69         ;   .69
            movwf      PDel1       ;   PDel1.

LOOP_2      movlw      .109        ;   .109
            movwf      PDel2       ;   PDel2.

LOOP_3      clrwdt                 ;    WDT.
;---------------------------------------------------------------------------------------------
;  TMR0   1 (     TimerH
; ,    , -      TimerHH).
;---------------------------------------------------------------------------------------------
            btfss      IntCon,2    ; TMR0   ?
            goto       DO_NOTHING  ;  -   DO_NOTHING.
   
            incfsz     TimerH,F    ;  -  TimerH, ,  TimerH  
            goto       RESET       ; ,     RESET.

            incf       TimerHH,F   ;  TimerH ,   TimerHH.
       
RESET       bcf        IntCon,2    ;    TMR0.
            goto       O_K         ;    O_K.

DO_NOTHING  goto       $+1         ;  
            goto       $+1         ;  22=4 ..
            clrwdt                 ;    1 ..    WDT.
;--------------------------------------------------------------------------------------------
;       "".
;--------------------------------------------------------------------------------------------            
O_K         decfsz     PDel2,F     ;      
            goto       LOOP_3      ;       .
                                   ;   =0,     LOOP_3.
            clrwdt                 ;   =0,     1 .. 
                                   ;     WDT.
            decfsz     PDel1,F     ;     
            goto       LOOP_2      ;       .
                                   ;   =0,     LOOP_2.
            goto       $+1         ;   =0, 
            goto       $+1         ;  
            goto       $+1         ; 32=6 ..

            decfsz     PDel0,F     ;     
            goto       LOOP_1      ;       .
                                   ;   =0,     LOOP_1.
                                   ;   =0,    .
;---------------------------------------------------------------------------------------------
;  ""      1000000 .
;---------------------------------------------------------------------------------------------
            movlw      .6          ;   .6
            movwf      PDel0       ;   PDel0.

DOVOD_1     movlw      .137        ;   .137
            movwf      PDel1       ;   PDel1.

DOVOD_2     clrwdt                 ;    WDT.
            decfsz     PDel1,F     ; ,
            goto       DOVOD_2     ; 2-,  
            decfsz     PDel0,F     ; ().
            goto       DOVOD_1     ;

            goto       $+1         ;  
            goto       $+1         ; 22=4 ..
;---------------------------------------------------------------------------------------------
;     Off.
;---------------------------------------------------------------------------------------------
            clrf       PortA       ;   0   PortA.
 
            bsf        Status,RP0  ;   1- .
            movlw      b'00010000' ;   W .
Off         movwf      TrisA       ;    W   TrisA:  RA4
                                   ;   , RA3   ( ).
            bcf        Status,RP0  ;   0- .
;---------------------------------------------------------------------------------------------
;  TMR0   2.
;---------------------------------------------------------------------------------------------
            btfss      IntCon,2    ; TMR0 ?
            goto       ANALYSE     ;  -    ANALYSE.

            incfsz     TimerH,F    ;  -  TimerH, ,  TimerH 
            goto       ANALYSE     ; ,     ANALYSE.

            incf       TimerHH,F   ;  TimerH ,   TimerHH.
;---------------------------------------------------------------------------------------------
;    TMR0   TimerM.
;---------------------------------------------------------------------------------------------
ANALYSE     movf       Tmr0,W      ;   TMR0
            movwf      TimerM      ;    TimerM.
;---------------------------------------------------------------------------------------------
;   0   TimerL.
;---------------------------------------------------------------------------------------------
            clrf       TimerL      ;   TimerL.
;---------------------------------------------------------------------------------------------
;  .
;---------------------------------------------------------------------------------------------
COUNT_IT    incf       TimerL,F    ;    TimerL.
;---------------------------------------------------------------------------------------------
;     TMR0.
;---------------------------------------------------------------------------------------------
            bsf        PortA,3     ;    RA3 .
            nop                    ;   1 ..
            bcf        PortA,3     ;    RA3 .
            nop                    ;   1 ..
            clrwdt                 ;    WDT.
;---------------------------------------------------------------------------------------------
;  .
;---------------------------------------------------------------------------------------------
            movf       Tmr0,W      ;   TMR0  W.
            bcf        Status,Z    ;     Z.
            subwf      TimerM,W    ;   TimerM  W    W.
            btfsc      Status,Z    ;       ?
            goto       COUNT_IT    ; ,  -->    COUNT_IT.
            incf       TimerL,F    ; ,   -->   TimerL.
            comf       TimerL,F    ;    TimerL.
            incf       TimerL,F    ;  TimerL.
            incf       TimerL,F    ;  TimerL.

            call       BIN2_10     ;     - .
;---->      BIN2_10.

;#############################################################################################
;        ASCII (ANSI).
;#############################################################################################
            movlw      30h         ;    W  30h.
            iorwf      LED0,F      ;  ""   W   LED0
                                   ;     LED0.
            iorwf      LED1,F      ;     LED1.
            iorwf      LED2,F      ; -------"------- LED2.
            iorwf      LED3,F      ; -------"------- LED3.
            iorwf      LED4,F      ; -------"------- LED4.
            iorwf      LED5,F      ; -------"------- LED5.
            iorwf      LED6,F      ; -------"------- LED6.
            iorwf      LED7,F      ; -------"------- LED7.
;#############################################################################################
;       ,  .
;#############################################################################################
            movlw      .7          ;     (8-1=7)
            movwf      Total       ;    Total.
;----------------------------------------------------------
;      LED... .
;----------------------------------------------------------
            movlw      LED7        ;      ""
            movwf      FSR         ;  , , LED7,    
                                   ;   LED (6,5,4,3,2,1,0)   W.

SNOVA_0     movlw      30h         ;   30h   W.
            subwf      IndF,W      ;        FSR ( 
                                   ;  LED)  30h     W.
;-------------------------------------
; 1-    .
;-------------------------------------
            btfss      Status,Z    ;      Z.
            goto       VIHOD       ;   W =0,     (goto VIHOD).
            movlw      20h         ;   W =0,    ""
            movwf      IndF        ;      FSR (  LED).
;-------------------------------------
;   ,  LED.
;-------------------------------------
            decf       FSR,F       ;    LED  1.
            decf       Total,F     ;      1.
;-------------------------------------
; 2-    .
;-------------------------------------
            btfss      Status,Z    ;      Z.
            goto       SNOVA_0     ;   Total =0,    
                                   ;     (goto SNOVA_0).
VIHOD       goto       DISPLAY     ;   Total =0,     
                                   ;   (  DISPLAY).
;#############################################################################################

;*********************************************************************************************
;  - .
;*********************************************************************************************
BIN2_10     bcf        Status,C    ;   -.
            movlw      .32         ; ""   Count1   ,
            movwf      Count1      ;      .
            clrf       LED0        ;   LED0.
            clrf       LED1        ; ------"------  LED1.
            clrf       LED2        ; ------"------  LED2.
            clrf       LED3        ; ------"------  LED3.
;---------------------------------------------------------------------------------------------
;        Status.
;---------------------------------------------------------------------------------------------
LOOP_16     rlf        TimerL,F    ;    4- , 
            rlf        TimerM,F    ;    TimerL/TimerM/TimerH/TimerHH,
            rlf        TimerH,F    ;        Status
            rlf        TimerHH,F   ; ---------------------------------------------------------

            rlf        LED0,F      ;    4- , 
            rlf        LED1,F      ;    LED0/LED1/LED2/LED3,
            rlf        LED2,F      ;        Status
            rlf        LED3,F      ; ---------------------------------------------------------

            decfsz     Count1,F    ;    Count1   
                                   ;    .
            goto       adjDEC      ;    = 0,     adjDEC,
                                   ;   = 0,    .
;---------------------------------------------------------------------------------------------
;     LED0...3
;     LED0...7.
;---------------------------------------------------------------------------------------------
            swapf      LED3,W      ;    LED3
            andlw      0Fh         ;    LED7
            movwf      LED7        ; -------------------------------

            movfw      LED3        ;    LED3
            andlw      0Fh         ;    LED6
            movwf      LED6        ; -------------------------------

            swapf      LED2,W      ;    LED2
            andlw      0Fh         ;    LED5
            movwf      LED5        ; -------------------------------

            movfw      LED2        ;    LED2
            andlw      0Fh         ;    LED4
            movwf      LED4        ; -------------------------------

            swapf      LED1,W      ;    LED1
            andlw      0Fh         ;    LED3
            movwf      LED3        ; -------------------------------

            movfw      LED1        ;    LED1
            andlw      0Fh         ;    LED2
            movwf      LED2        ; -------------------------------

            swapf      LED0,W      ;    LED0
            andlw      0Fh         ;    LED1
            movwf      LED1        ; -------------------------------

            movfw      LED0        ;    LED0
            andlw      0Fh         ;    LED0
            movwf      LED0        ; -------------------------------

            return
;---------------------------------------------------------------------------------------------
;    FSR   LED0...3    
;     adjBCD.
;     LED -    .
;---------------------------------------------------------------------------------------------
adjDEC      movlw      LED0        ;    FSR   LED0
            movwf      FSR         ;      adjBCD.
            call       adjBCD      ;
;--->      adjBCD.
            movlw      LED1        ;      LED1.
            movwf      FSR         ;
            call       adjBCD      ;
;--->      adjBCD.
            movlw      LED2        ;      LED2.
            movwf      FSR         ;
            call       adjBCD      ;
;--->      adjBCD.
            movlw      LED3        ;      LED3.
            movwf      FSR         ;
            call       adjBCD      ;
;--->      adjBCD.
            goto       LOOP_16     ;      .
;---------------------------------------------------------------------------------------------
;       -:
;   LED0...3   03h  30h    3-  7- .
;---------------------------------------------------------------------------------------------
adjBCD      clrwdt                 ;    WDT.
            movlw      3           ;    LED (LED0...3)  
            addwf      0,W         ; 03h,    ,   W,
            movwf      Mem         ;   Mem.

            btfsc      Mem,3       ;    3  Mem.
            movwf      0           ;   3 = 1,    Mem
                                   ;    LED.
 
            movlw      30          ;   3 = 0,    LED 
            addwf      0,W         ;   30h,   
            movwf      Mem         ; ,   W,   Mem.

            btfsc      Mem,7       ;    7  Mem.
            movwf      0           ;   7 = 1,    Mem
                                   ;    LED.

            retlw      0           ;   7 = 0,   W   
                                   ;      adjDEC.
;*********************************************************************************************
 ;     15 
WAIT_15M     movlw     .121
             movwf     TEMP
             movlw     .20
             movwf     TEMP2
LOOP1        CLRWDT
             DECFSZ    TEMP
             GOTO      LOOP1   
             DECFSZ    TEMP2
             GOTO      LOOP1
             RETLW     0
;delay = 5'000 machine cycles 5 
WAIT_5M       movlw       .125
            movwf       TEMP2
            movlw       .7
            movwf       TEMP
wr1         CLRWDT
            decfsz      TEMP2, F
            goto        wr1
            decfsz      TEMP, F
            goto        wr1
            RETLW       0
  ;delay = 250 machine cycles 250
WAIT_250    movlw       .83
            movwf       TEMP
wr9         decfsz      TEMP, F
            goto        wr9
            RETURN
  ;delay = 100 machine cycles 100
WAIT_100    movlw       .33
            movwf       TEMP
wr10        decfsz      TEMP, F
            goto        wr10
            RETURN
;delay = 1'640 machine cycles  1.64 
WAIT_1M6    movlw       .30
            movwf       TEMP2
            movlw       .3
            movwf       TEMP
wr11        decfsz      TEMP2, F
            goto        wr11
            clrwdt
            decfsz      TEMP, F
            goto        wr11
            nop
            nop
            RETURN
;delay = 10 machine cycles
WAIT40      movlw       .3
            movwf       TEMP
wr40        decfsz      TEMP, F
            goto        wr40

            RETURN
;*********************************************************************************************
            end                    ;  .
